diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
similarity index 91%
rename from game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index 8bf4f9f0d..357ff1c97 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -1,11 +1,10 @@
 package net.minecraft.core.block.piston;
 
-import java.util.ArrayList;
-
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -21,7 +20,7 @@ import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockPistonBase extends Block
+public class BlockLogicPistonBase extends BlockLogic
 {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int MASK_POWERED = 0b0000_1000;
@@ -31,11 +30,11 @@ public class BlockPistonBase extends Block
 
     private final int maxPushedBlocks;
 
-    public BlockPistonBase(String key, String namespaceId, int id, int maxPushedBlocks)
+    public BlockLogicPistonBase(Block<?> block, int maxPushedBlocks)
     {
-        super(key, namespaceId, id, Material.piston);
+        super(block, Material.piston);
         this.maxPushedBlocks = maxPushedBlocks;
-        withHardness(0.5F);
+        block.withHardness(0.5F);
     }
 
     @Override
@@ -175,8 +174,8 @@ public class BlockPistonBase extends Block
                 world.setBlock(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), 0);
             }
         }
-        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, direction.getId());
-        world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(id, direction.getId(), null, direction, false, true));
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id(), direction.getId());
+        world.replaceBlockTileEntity(x, y, z, BlockLogicPistonMoving.createTileEntity(block.id(), direction.getId(), null, direction, false, true));
         world.setBlockWithNotify(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), 0);
         world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
     }
@@ -227,7 +226,7 @@ public class BlockPistonBase extends Block
     
     protected boolean isPushable(int id, World world, int x, int y, int z, boolean canDestroy)
     {
-        Block block = Blocks.getBlock(id);
+        Block<?> block = Blocks.getBlock(id);
         if (block == null) return false;
         int pushReaction = block.getPistonPushReaction(world, x, y, z);
         if (block.hasTag(BlockTags.PISTON_CRUSHING) ||
@@ -289,7 +288,7 @@ public class BlockPistonBase extends Block
         int x2 = x + direction.getOffsetX();
         int y2 = y + direction.getOffsetY();
         int z2 = z + direction.getOffsetZ();
-        Block block = world.getBlock(x2, y2, z2);
+        Block<?> block = world.getBlock(x2, y2, z2);
         if (block == null) return true;
         world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, x2, y2, z2, world.getBlockId(x2, y2, z2));
         block.dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x2, y2, z2, world.getBlockMetadata(x2, y2, z2), null, null);
@@ -340,10 +339,10 @@ public class BlockPistonBase extends Block
             if (pushEntity instanceof TileEntityMovingPistonBlock && px == x && py == y && pz == z) {
                 break;
             }
-            if(pushId == id && px == x && py == y && pz == z)
+            if(pushId == block.id() && px == x && py == y && pz == z)
             {
                 createPistonHeadAt(world, xo, yo, zo, data, direction);
-            } else if (pushId == Blocks.PISTON_MOVING.id)
+            } else if (pushId == Blocks.PISTON_MOVING.id())
             {
                 TileEntity old = world.getBlockEntity(px, py, pz);
                 if (old instanceof TileEntityMovingPistonBlock) {
@@ -355,13 +354,13 @@ public class BlockPistonBase extends Block
                     }
                 }
                 world.removeBlockTileEntity(px, py, pz);
-                world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id, pushMeta);
-                world.replaceBlockTileEntity(xo, yo, zo, BlockPistonMoving.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
+                world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id(), pushMeta);
+                world.replaceBlockTileEntity(xo, yo, zo, BlockLogicPistonMoving.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
             } else
             {
                 world.removeBlockTileEntity(px, py, pz);
-                world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id, pushMeta);
-                world.replaceBlockTileEntity(xo, yo, zo, BlockPistonMoving.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
+                world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id(), pushMeta);
+                world.replaceBlockTileEntity(xo, yo, zo, BlockLogicPistonMoving.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
             }
             if (!(px == x && py == y && pz == z))
                 world.setBlockAndMetadataRaw(px, py, pz, 0, 0);
@@ -374,8 +373,8 @@ public class BlockPistonBase extends Block
     }
 
     public void createPistonHeadAt(World world, int x, int y, int z, int data, Direction direction) {
-        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, BlockPistonHead.setPistonType(BlockPistonHead.TYPE_NORMAL, direction.getId()));
-        world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(Blocks.PISTON_HEAD.id, BlockPistonHead.setPistonType(BlockPistonHead.TYPE_NORMAL, direction.getId()), null, direction, true, false));
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_NORMAL, direction.getId()));
+        world.replaceBlockTileEntity(x, y, z, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_NORMAL, direction.getId()), null, direction, true, false));
     }
     
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
index b1db533be..d338c927d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.block.piston;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityFallingBlock;
@@ -18,13 +18,13 @@ import net.minecraft.core.world.WorldSource;
 import java.util.ArrayList;
 import java.util.List;
 
-public class BlockPistonBaseSteel extends BlockPistonBase {
+public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
     public static final double HEAD_THICKNESS_STEEL = 6/16d;
 
     private Entity flungBlock = null;
 
-    public BlockPistonBaseSteel(String key, String namespaceId, int id, int maxPushedBlocks) {
-        super(key, namespaceId, id, maxPushedBlocks);
+    public BlockLogicPistonBaseSteel(Block<?> container, int maxPushedBlocks) {
+        super(container, maxPushedBlocks);
     }
 
     @Override
@@ -96,13 +96,13 @@ public class BlockPistonBaseSteel extends BlockPistonBase {
             xo = x + direction.getOffsetX();
             yo = y + direction.getOffsetY();
             zo = z + direction.getOffsetZ();
-            Block block = world.getBlock(xo, yo, zo);
+            Block<?> block = world.getBlock(xo, yo, zo);
             if (block == null) return true;
             int blockMeta = world.getBlockMetadata(xo, yo, zo);
             TileEntity tileEntity = world.getBlockEntity(xo, yo, zo);
             world.removeBlockTileEntity(xo, yo, zo);
             world.setBlockWithNotify(xo, yo, zo, 0);
-            EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, xo + 0.5, yo + 0.5, zo + 0.5, block.id, blockMeta, tileEntity);
+            EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, xo + 0.5, yo + 0.5, zo + 0.5, block.id(), blockMeta, tileEntity);
             entityFallingBlock.hasRemovedBlock = true;
             if (tileEntity instanceof IVehicle) {
                 Entity rider = ((IVehicle) tileEntity).getPassenger();
@@ -122,7 +122,7 @@ public class BlockPistonBaseSteel extends BlockPistonBase {
         int x2 = x + direction.getOffsetX();
         int y2 = y + direction.getOffsetY();
         int z2 = z + direction.getOffsetZ();
-        Block block = world.getBlock(x2, y2, z2);
+        Block<?> block = world.getBlock(x2, y2, z2);
         if (block == null) return true;
         world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, x2, y2, z2, world.getBlockId(x2, y2, z2));
         block.dropBlockWithCause(world, EnumDropCause.PISTON_CRUSH, x2, y2, z2, world.getBlockMetadata(x2, y2, z2), null, null);
@@ -144,8 +144,8 @@ public class BlockPistonBaseSteel extends BlockPistonBase {
 
     @Override
     public void createPistonHeadAt(World world, int x, int y, int z, int data, Direction direction) {
-        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id,  BlockPistonHead.setPistonType(BlockPistonHead.TYPE_STEEL, direction.getId()));
-        world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(Blocks.PISTON_HEAD_STEEL.id, BlockPistonHead.setPistonType(BlockPistonHead.TYPE_STEEL, direction.getId()), null, direction, true, false));
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id(),  BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STEEL, direction.getId()));
+        world.replaceBlockTileEntity(x, y, z, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD_STEEL.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STEEL, direction.getId()), null, direction, true, false));
     }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
similarity index 73%
rename from game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
index caf6c3129..d10a577f1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonBaseSticky.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
@@ -1,16 +1,16 @@
 package net.minecraft.core.block.piston;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 
-public class BlockPistonBaseSticky extends BlockPistonBase {
-    public BlockPistonBaseSticky(String key, String namespaceId, int id, int maxPushedBlocks) {
-        super(key, namespaceId, id, maxPushedBlocks);
+public class BlockLogicPistonBaseSticky extends BlockLogicPistonBase {
+    public BlockLogicPistonBaseSticky(Block<?> block, int maxPushedBlocks) {
+        super(block, maxPushedBlocks);
     }
 
     @Override
@@ -25,8 +25,8 @@ public class BlockPistonBaseSticky extends BlockPistonBase {
                 world.setBlock(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), 0);
             }
         }
-        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, direction.getId());
-        world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(id, direction.getId(), null, direction, false, true));
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id(), direction.getId());
+        world.replaceBlockTileEntity(x, y, z, BlockLogicPistonMoving.createTileEntity(block.id(), direction.getId(), null, direction, false, true));
         int x1 = x + direction.getOffsetX() * 2;
         int y1 = y + direction.getOffsetY() * 2;
         int z1 = z + direction.getOffsetZ() * 2;
@@ -34,7 +34,7 @@ public class BlockPistonBaseSticky extends BlockPistonBase {
         int retactMeta = world.getBlockMetadata(x1, y1, z1);
         TileEntity retractEntity = world.getBlockEntity(x1, y1, z1);
         boolean pulledMoving = false;
-        if(retractId == Blocks.PISTON_MOVING.id)
+        if(retractId == Blocks.PISTON_MOVING.id())
         {
             TileEntity tileEntity1 = world.getBlockEntity(x1, y1, z1);
             if((tileEntity1 instanceof TileEntityMovingPistonBlock))
@@ -50,9 +50,10 @@ public class BlockPistonBaseSticky extends BlockPistonBase {
                 }
             }
         }
-        if(!pulledMoving && retractId > 0 &&
+        Block<?> retractedBlock = Blocks.getBlock(retractId);
+        if(!pulledMoving && retractedBlock != null &&
             isPushable(retractId, world, x1, y1, z1, false) &&
-            (Blocks.blocksList[retractId].getPistonPushReaction(world, x1, y1, z1) == Material.PISTON_PUSHABLE || (Blocks.getBlock(retractId) instanceof BlockPistonBase)))
+            (retractedBlock.getPistonPushReaction(world, x1, y1, z1) == Material.PISTON_PUSHABLE || (retractedBlock.getLogic() instanceof BlockLogicPistonBase)))
         {
             if (!(retractEntity instanceof TileEntityMovingPistonBlock)) {
                 world.removeBlockTileEntity(x1, y1, z1);
@@ -61,8 +62,8 @@ public class BlockPistonBaseSticky extends BlockPistonBase {
             x += direction.getOffsetX();
             y += direction.getOffsetY();
             z += direction.getOffsetZ();
-            world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, retactMeta);
-            world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(retractId, retactMeta, retractEntity, direction, false, false));
+            world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id(), retactMeta);
+            world.replaceBlockTileEntity(x, y, z, BlockLogicPistonMoving.createTileEntity(retractId, retactMeta, retractEntity, direction, false, false));
             world.notifyBlockChange(x1, y1, z1, 0);
         } else
         if(!pulledMoving)
@@ -73,7 +74,7 @@ public class BlockPistonBaseSticky extends BlockPistonBase {
     }
     @Override
     public void createPistonHeadAt(World world, int x, int y, int z, int data, Direction direction) {
-        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id,  BlockPistonHead.setPistonType(BlockPistonHead.TYPE_STICKY, direction.getId()));
-        world.replaceBlockTileEntity(x, y, z, BlockPistonMoving.createTileEntity(Blocks.PISTON_HEAD.id, BlockPistonHead.setPistonType(BlockPistonHead.TYPE_STICKY, direction.getId()), null, direction, true, false));
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id(),  BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STICKY, direction.getId()));
+        world.replaceBlockTileEntity(x, y, z, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STICKY, direction.getId()), null, direction, true, false));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
similarity index 91%
rename from game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
index 6a6ca3fe7..8d031144e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
@@ -2,10 +2,11 @@ package net.minecraft.core.block.piston;
 
 import java.util.ArrayList;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
@@ -14,7 +15,7 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockPistonHead extends Block
+public class BlockLogicPistonHead extends BlockLogic
 {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int MASK_TYPE = 0b1111_1000;
@@ -23,10 +24,10 @@ public class BlockPistonHead extends Block
     public static final int TYPE_STEEL = 2;
 
     private final double headThickness;
-    public BlockPistonHead(String key, String namespaceId, int id, double headThickness)
+    public BlockLogicPistonHead(Block<?> block, double headThickness)
     {
-        super(key, namespaceId, id, Material.piston);
-        withHardness(0.5F);
+        super(block, Material.piston);
+        block.withHardness(0.5F);
         this.headThickness = headThickness;
     }
 
@@ -42,11 +43,11 @@ public class BlockPistonHead extends Block
         int x2 = x + orientation.getOffsetX();
         int y2 = y + orientation.getOffsetY();
         int z2 = z + orientation.getOffsetZ();
-        Block block = world.getBlock(x2, y2, z2);
-        if(block instanceof BlockPistonBase)
+        Block<?> block = world.getBlock(x2, y2, z2);
+        if(block != null && block.getLogic() instanceof BlockLogicPistonBase)
         {
             int data2 = world.getBlockMetadata(x2, y2, z2);
-            if(BlockPistonBase.isPowered(data2))
+            if(BlockLogicPistonBase.isPowered(data2))
             {
                 block.dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x2, y2, z2, data2, null, null);
                 world.setBlockWithNotify(x2, y2, z2, 0);
@@ -139,8 +140,8 @@ public class BlockPistonHead extends Block
         if(direction == Direction.NONE) {
         	return;
         }
-        Block block = world.getBlock(x - direction.getOffsetX(), y - direction.getOffsetY(), z - direction.getOffsetZ());
-        if (block instanceof BlockPistonBase) {
+        Block<?> block = world.getBlock(x - direction.getOffsetX(), y - direction.getOffsetY(), z - direction.getOffsetZ());
+        if (block != null && block.getLogic() instanceof BlockLogicPistonBase) {
             block.onNeighborBlockChange(world, x - direction.getOffsetX(), y - direction.getOffsetY(), z - direction.getOffsetZ(), blockId);
         } else {
             world.setBlockWithNotify(x, y, z, 0);
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
similarity index 91%
rename from game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
rename to game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
index 8f2887ba2..8d51ad975 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.block.piston;
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockTileEntity;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -15,18 +15,13 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockPistonMoving extends BlockTileEntity
+public class BlockLogicPistonMoving extends BlockLogic
 {
-    public BlockPistonMoving(String key, String namespaceId, int id)
+    public BlockLogicPistonMoving(Block<?> container)
     {
-        super(key, namespaceId, id, Material.piston);
-        withHardness(-1F);
-    }
-
-    @Override
-	protected TileEntity getNewBlockEntity()
-    {
-        return null;
+        super(container, Material.piston);
+        container.withHardness(-1F);
+        container.withEntity(null);
     }
 
     @Override
@@ -144,8 +139,8 @@ public class BlockPistonMoving extends BlockTileEntity
         TileEntityMovingPistonBlock pistonBlockEntity = getBlockEntity(world, x, y, z);
         if(pistonBlockEntity != null)
         {
-            Block block = Blocks.blocksList[pistonBlockEntity.getMovedId()];
-            if(block == null || block == this)
+            Block<?> block = Blocks.blocksList[pistonBlockEntity.getMovedId()];
+            if(block == null || block == this.block)
             {
                 return getBlockBoundsFromState(world, x, y, z);
             }
@@ -164,12 +159,12 @@ public class BlockPistonMoving extends BlockTileEntity
             otherBounds.minZ - direction.getOffsetZ() * f,
             otherBounds.maxZ - direction.getOffsetZ() * f);
         }
-        return getBlockBoundsFromState(world, x, y, z);
+        return super.getBlockBoundsFromState(world, x, y, z);
     }
 
     public AABB getCollisionShapeFromTileEntity(WorldSource world, int x, int y, int z, int blockID, float directionStretch, Direction direction)
     {
-        if(blockID == 0 || blockID == id)
+        if(blockID == 0 || blockID == block.id())
         {
             return null;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index d42b85a25..f2e3b4510 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -1,10 +1,9 @@
 package net.minecraft.core.block.piston;
 
-import net.minecraft.core.block.BlockTileEntity;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityDispatcher;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
@@ -124,7 +123,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
         {
             stretch = 1.0F - stretch;
         }
-        AABB aabb = ((BlockPistonMoving) Blocks.PISTON_MOVING).getCollisionShapeFromTileEntity(worldObj, x, y, z, movedId, stretch, direction);
+        AABB aabb = Blocks.PISTON_MOVING.getLogic().getCollisionShapeFromTileEntity(worldObj, x, y, z, movedId, stretch, direction);
         if (aabb == null) return;
 
         List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(null, aabb);
@@ -144,7 +143,7 @@ public class TileEntityMovingPistonBlock extends TileEntity
         progressO = progress = 1.0F;
         worldObj.removeBlockTileEntity(x, y, z);
         invalidate();
-        if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id) {
+        if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id()) {
             worldObj.setBlockAndMetadataRaw(x, y, z, movedId, movedData);
             if (movedEntity != null) {
                 TileEntity oldEnt = worldObj.getBlockEntity(x, y, z);
@@ -158,9 +157,9 @@ public class TileEntityMovingPistonBlock extends TileEntity
                 worldObj.replaceBlockTileEntity(x, y, z, movedEntity);
             }
             if (movedId != 0) {
-                BlockTileEntity.createNewEntityOnPlace = false;
+                Block.disableNormalEntityLogic = true;
                 Blocks.blocksList[movedId].onBlockPlacedByWorld(worldObj, x, y, z);
-                BlockTileEntity.createNewEntityOnPlace = true;
+                Block.disableNormalEntityLogic = false;
             }
             assert movedEntity == null || worldObj.getBlockEntity(x, y, z) == movedEntity : "Piston failed to actually move entity!";
             worldObj.notifyBlockChange(x, y, z, movedId);
diff --git a/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java b/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
index b472066d1..f7fcb3828 100644
--- a/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/support/ISupportable.java
@@ -8,7 +8,7 @@ public interface ISupportable {
     ISupport getSupportConstraint(final World world, final int x, final int y, final int z, final Side side);
 
     default boolean isSupported(final World world, final int x, final int y, final int z, final Side side) {
-        final Block supportingBlock = world.getBlock(x, y, z);
+        final Block<?> supportingBlock = world.getBlock(x, y, z);
         if (supportingBlock == null) {
             return false;
         }
